<template>
  <Modal v-model="isShow" :close="closeModal">
    <div class="lunaConnectModal textDark">
      <h4 class="textDark">{{ modalTitle }}</h4>
      <p class="paragraphClass">
        NodeMCU es una plataforma IoT<br />
        basado en el lenguaje Lua <br />
        y el microcontrolador esp8266.
      </p>
      <!-- SUPPORTED METHODS -->
      <div class="lunaConnect">
        <p class="paragraphClass">{{ modalDescription }}</p>
        <!-- Tres posibles modos para NodeMCU [APWIFI, STAWIFI, USB] -->
        <!-- SELECCIONAR MODO NODEMCU APWIFI -->
        <a
          v-show="luna8266.shippingMethodSupport(ShippingMethod.APWIFI)"
          :class="{
            aIconConnectMode: true,
            iModeShippingSelected:
              methodShippingSelected == ShippingMethod.APWIFI,
          }"
          v-on:click="selectMethodShipping(ShippingMethod.APWIFI)"
          title="Dar clic aquí si deasea activar la conexión Access Point con NodeMCU"
        >
          <i>
            <font-awesome-icon :icon="['fas', 'tower-cell']" size="2x" />
          </i>
        </a>
        <!-- SELECCIONAR MODO NODEMCU STAWIFI -->
        <a
          v-show="luna8266.shippingMethodSupport(ShippingMethod.STAWIFI)"
          :class="{
            aIconConnectMode: true,
            iModeShippingSelected:
              methodShippingSelected == ShippingMethod.STAWIFI,
          }"
          v-on:click="selectMethodShipping(ShippingMethod.STAWIFI)"
          title="Dar clic aquí si deasea activar la conexión con NodeMCU como estación WiFi"
        >
          <i>
            <font-awesome-icon :icon="['fas', 'house-signal']" size="2x" />
          </i>
        </a>
        <!-- SELECCIONAR MODO NODEMCU USB -->
        <a
          v-show="luna8266.shippingMethodSupport(ShippingMethod.USB)"
          :class="{
            aIconConnectMode: true,
            iModeShippingSelected: methodShippingSelected == ShippingMethod.USB,
          }"
          v-on:click="selectMethodShipping(ShippingMethod.USB)"
          title="Dar clic aquí si deasea activar la conexión USB con NodeMCU"
        >
          <i>
            <font-awesome-icon :icon="['fab', 'usb']" size="2x" />
          </i>
        </a>
      </div>
      <!-- IF APWIFI METHOD IS SELECTED -->
      <div v-show="methodShippingSelected == ShippingMethod.APWIFI">
        <p
          class="paragraphClass"
          title="Se ha seleccionado el modo de conexión NodeMCU como punto de acceso WiFi"
        >
          Se ha seleccionado el modo
          <span class="spanSelected">punto de acceso wifi</span>
        </p>
        <p class="paragraphClass">IP: {{ ipAPLabel }}</p>
        <div class="lunaConnect">
          <p
            class="paragraphClass"
            title="Dar clic en el ícono para probar conexión con NodeMCU en modo punto de acceso"
          >
            Probar conexión:
          </p>
          <div class="animate__animated animate__pulse animate__infinite">
            <a
              v-show="luna8266.shippingMethodSupport(ShippingMethod.APWIFI)"
              :class="{
                aIconConnectMode: true,
              }"
              v-on:click="testConnect()"
              :style="{ color: iconColorAPNodeMCUStyle }"
              title="Dar clic aquí para iniciar probar conexión con NodeMCU"
            >
              <i>
                <font-awesome-icon :icon="iconAPNodeMCUState" size="2x" />
              </i>
            </a>
          </div>
        </div>
      </div>
      <!-- IF STAWIFI METHOD -->
      <div v-show="methodShippingSelected == ShippingMethod.STAWIFI">
        <p
          class="paragraphClass"
          title="Se ha seleccionado el modo de conexión NodeMCU como estación WiFi"
        >
          Se ha seleccionado el modo
          <span class="spanSelected">Estación wifi</span>
        </p>
        <div>
          <span>Conectarse a una tarjeta de desarrollo</span>
        </div>
        <div class="lunaConnect">
          <div>
            <span>Red: {{ issdLabel }}, IP: {{ ipSTALabel }} </span>
          </div>
          <div>
            <span>
              Seleccionar IP:
              <input placeholder="Editar IP" v-model="ipSTAEdit" />
            </span>
          </div>
          <span>
            Probar conexión:
            <div class="animate__animated animate__pulse animate__infinite">
              <a
                v-show="luna8266.shippingMethodSupport(ShippingMethod.STAWIFI)"
                :class="{
                  aIconConnectMode: true,
                }"
                v-on:click="testConnect()"
                :style="{ color: iconColorSTANodeMCUStyle }"
                title="Dar clic aquí para iniciar probar conexión con NodeMCU"
              >
                <i>
                  <font-awesome-icon :icon="iconSTANodeMCUState" size="2x" />
                </i>
              </a>
            </div>
          </span>
        </div>
        <div>
          <span>¿No tiene una IP para conectarse?</span>
        </div>
        <div class="lunaConnect">
          <div style="text-align: center">
            <span>Escanear dispositivos conectados a la red</span>
          </div>
          <div style="text-align: left">
            <span>
              <button v-on:click="stopScanConnect()">Mostart IPs</button>
              <button v-on:click="initScanConnect()">Iniciar scaner</button>
            </span>
          </div>
          <div>
            <span>Lista de dispositivos encontrados:</span>
            <li v-for="(item, index) in items" style="text-align: left">
              <button v-on:click="selectSTAIP(index)">Seleccionar ip:</button>
              {{ item }}
            </li>
          </div>
        </div>
      </div>
      <!-- IF USB METHOD -->
      <div v-show="methodShippingSelected == ShippingMethod.USB">
        <p
          class="paragraphClass"
          title="Se ha seleccionado el modo de conexión USB con NodeMCU"
        >
          Se ha seleccionado el modo
          <span class="spanSelected">USB</span>
        </p>
        <div class="lunaConnect">
          <div>
            <button v-on:click="scanSerialPortList()">
              Escanear puertos USB
            </button>
          </div>
          <span> Seleccionar dispositivo USB:&nbsp; </span>
          <select v-model="serialPortSelected">
            <option v-for="serialPort in serialPorts">
              {{ serialPort.path }}
            </option>
          </select>
        </div>
        <div class="lunaConnect">
          <span>Dispositivo USB seleccionado:&nbsp; {{ serialPortSelected }}</span>
          <p
            class="paragraphClass"
            title="Dar clic en el ícono para probar conexión con NodeMCU por USB"
          >
            Probar conexión USB:
          </p>
          <div class="animate__animated animate__pulse animate__infinite">
            <a
              v-show="luna8266.shippingMethodSupport(ShippingMethod.USB)"
              :class="{
                aIconConnectMode: true,
              }"
              v-on:click="testConnect()"
              :style="{ color: iconColorUSBNodeMCUStyle }"
              title="Dar clic aquí para iniciar probar conexión con NodeMCU"
            >
              <i>
                <font-awesome-icon :icon="iconUSBNodeMCUState" size="2x" />
              </i>
            </a>
          </div>
        </div>
      </div>
      <p></p>
      <p></p>
      <button v-on:click="closeModal">Cerrar</button>
    </div>
  </Modal>
</template>

<script lang="ts">
import { defineComponent, ref, watch, onMounted } from "vue";
import "animate.css"; // https://animate.style/
import {
  luna8266,
  ShippingMethod,
  StatusTask,
  sleep,
  toastMsg,
  log,
} from "../../../../host/index";

import { FontAwesomeIcon } from "@fortawesome/vue-fontawesome";
import { library } from "@fortawesome/fontawesome-svg-core";
import {
  faTowerCell,
  faArrowLeft,
  faHouseSignal,
  faPlugCircleExclamation,
  faPlugCircleCheck,
  faPlugCircleXmark,
  faPlug,
  faSave,
  faUndo,
  faRedo,
} from "@fortawesome/free-solid-svg-icons";
import { faUsb } from "@fortawesome/free-brands-svg-icons";
library.add(
  faTowerCell,
  faArrowLeft,
  faHouseSignal,
  faUsb,
  faPlugCircleExclamation,
  faPlugCircleCheck,
  faPlugCircleXmark,
  faPlug,
  faSave,
  faUndo,
  faRedo
);

export default defineComponent({
  components: {
    "font-awesome-icon": FontAwesomeIcon,
  },
  props: ["trigger"],
  emits: ["closeConnecModal"],
  // emits: ["setFileProject"],
  setup(props, context) {
    const modalTitle = ref("NodeMCU esp8266");
    const modalDescription = ref(
      "Seleccionar un modo de conexión con la tarjeta:"
    );
    const isShow = ref(false);
    const errorLoadFile = ref();
    const methodShippingSelected = ref(luna8266.getShippinMethodSelected());
    const ipAPLabel = ref();
    const ipSTALabel = ref();
    const ipSTAEdit = ref();
    const issdLabel = ref();
    const items = ref();
    let countSearchIp = 0;

    // Posibles íconos para el estado de conexión de NodeMCU
    const IconNodeMCUStateList: Array<Array<string>> = [];
    IconNodeMCUStateList[StatusTask.SUCCESS] = ["fas", "plug-circle-check"];
    IconNodeMCUStateList[StatusTask.INPROCESS] = [
      "fas",
      "plug-circle-exclamation",
    ];
    IconNodeMCUStateList[StatusTask.IDLE] = ["fas", "plug-circle-exclamation"];
    IconNodeMCUStateList[StatusTask.ERROR] = ["fas", "plug-circle-xmark"];
    const iconAPNodeMCUState = ref();
    const iconSTANodeMCUState = ref();
    const iconUSBNodeMCUState = ref();

    // Colores del ícono para los estados de conexión de chuck
    const iconColorNodeMCUStyleList: Array<string> = [];
    iconColorNodeMCUStyleList[StatusTask.INPROCESS] = "yellow";
    iconColorNodeMCUStyleList[StatusTask.SUCCESS] = "green";
    iconColorNodeMCUStyleList[StatusTask.ERROR] = "red";
    iconColorNodeMCUStyleList[StatusTask.IDLE] = "white";
    const iconColorAPNodeMCUStyle = ref();
    const iconColorSTANodeMCUStyle = ref();
    const iconColorUSBNodeMCUStyle = ref();

    function initIconsIDLE() {
      iconAPNodeMCUState.value = IconNodeMCUStateList[StatusTask.IDLE];
      iconColorAPNodeMCUStyle.value =
        iconColorNodeMCUStyleList[StatusTask.IDLE];
      iconSTANodeMCUState.value = IconNodeMCUStateList[StatusTask.IDLE];
      iconColorSTANodeMCUStyle.value =
        iconColorNodeMCUStyleList[StatusTask.IDLE];
      iconUSBNodeMCUState.value = IconNodeMCUStateList[StatusTask.IDLE];
      iconColorUSBNodeMCUStyle.value =
        iconColorNodeMCUStyleList[StatusTask.IDLE];
    }

    // Actualizar ícono y color del ícono en función del estado de la tarea.
    function iconAndColorStateUpdate(state: StatusTask) {
      switch (luna8266.getShippinMethodSelected()) {
        case ShippingMethod.APWIFI:
          iconAPNodeMCUState.value = IconNodeMCUStateList[state];
          iconColorAPNodeMCUStyle.value = iconColorNodeMCUStyleList[state];
          break;
        case ShippingMethod.STAWIFI:
          iconSTANodeMCUState.value = IconNodeMCUStateList[state];
          iconColorSTANodeMCUStyle.value = iconColorNodeMCUStyleList[state];
          break;
        case ShippingMethod.USB:
          iconUSBNodeMCUState.value = IconNodeMCUStateList[state];
          iconColorUSBNodeMCUStyle.value = iconColorNodeMCUStyleList[state];
          break;
      }
    }

    function selectMethodShipping(method: ShippingMethod) {
      luna8266.setShippinMethod(method);
      methodShippingSelected.value = luna8266.getShippinMethodSelected();
    }

    function showModal() {
      isShow.value = true;
    }

    function closeModal() {
      isShow.value = false;
      context.emit("closeConnecModal");
    }

    function selectSTAIP(ip: number) {
      ipSTAEdit.value = items.value[ip];
      testConnect();
    }

    async function stopScanConnect() {
      // TODO ya no es posible detener la búsqueda
      // debido a que las búsquedas se hacen asíncronamente
      // lo que se puede hacer ahora es que si aparece
      // un dispositivo, se pueda obtener esa ip con el botón
      // la busqueda continuará hasta que haga las 265 búsquedas
      // countSearchIp = 256;
      // para obtener se se hace como sigue:
      items.value = [];
      items.value = await luna8266.getValideEsp8266IpList();
    }

    async function initScanConnect() {
      items.value = [];
      toastMsg({
        data: "Iniciando proceso de escaner de dispositivos",
        time: 4000,
      });
      items.value = await luna8266.scanEsp8266ByIP();
      toastMsg({
        data: "Proceso terminado",
      });
    }

    // TODO: función sin uso y que puede ser borrada
    async function initScanConnect1() {
      countSearchIp = 0;
      items.value = [];
      if (
        methodShippingSelected.value == ShippingMethod.APWIFI ||
        methodShippingSelected.value == ShippingMethod.STAWIFI
      ) {
        for (countSearchIp; countSearchIp < 256; countSearchIp++) {
          const thisIp = "192.168.1." + countSearchIp;
          luna8266.setIPSTA(thisIp);
          let statusConnectWithLuna = StatusTask.INPROCESS;
          await luna8266.testConnectLuna8266();
          const attempts = 20;
          let count = 0;
          toastMsg({
            data: "Probando la dirección ip: " + thisIp,
            type: "warning",
            time: 400,
          });
          while (
            statusConnectWithLuna == StatusTask.INPROCESS &&
            count < attempts
          ) {
            await sleep(100);
            statusConnectWithLuna = luna8266.getStatusConnectLuna();
            if (statusConnectWithLuna == StatusTask.INPROCESS) {
              count++;
            } else if (statusConnectWithLuna == StatusTask.SUCCESS) {
              items.value.push(luna8266.getIPSTA());
              log("Se ha detectado una ip válida: " + luna8266.getIPSTA());
              break;
            } else {
              break;
            }
          }
        }
      }
    }

    async function testConnect() {
      // si hace uso de una conexión como STA
      luna8266.setIPSTA(ipSTAEdit.value);
      // Inicio de prueba
      if (methodShippingSelected.value == ShippingMethod.USB) {
        if (luna8266.getStatusConnectLuna() == StatusTask.SUCCESS) {
          await luna8266.usbDisconnect();
        }
        if (serialPortSelected.value == undefined) {
          toastMsg({
            data: "Seleccione un puerto USB válido",
            type: "warning",
            time: 2000,
          });
          return;
        }
        await luna8266.testUSBConnectLuna8266(serialPortSelected.value);
      } else {
        if (await luna8266.testConnectLuna8266() == false) {
          return;
        }
      }
      // Inicio de monitoreo de prueba
      let statusConnectWithLuna = StatusTask.INPROCESS;
      const attempts = 4;
      let count = 0;
      while (
        statusConnectWithLuna == StatusTask.INPROCESS &&
        count < attempts
      ) {
        statusConnectWithLuna = luna8266.getStatusConnectLuna();
        if (statusConnectWithLuna == StatusTask.SUCCESS) {
          toastMsg({
            data: "Prueba de conexión exitosa",
            type: "success",
            time: 5000,
          });
          if (
            methodShippingSelected.value == ShippingMethod.APWIFI ||
            methodShippingSelected.value == ShippingMethod.STAWIFI
          ) {
            await luna8266.updateIPSTAandSSID();
            issdLabel.value = luna8266.getSsidSTA();
            ipSTALabel.value = luna8266.getIPSTA();
          }
        } else if (statusConnectWithLuna == StatusTask.ERROR) {
          toastMsg({
            data: "No fue posible establecer conexion con la tarjeta",
            type: "error",
            time: 5000,
          });
        } else if (statusConnectWithLuna == StatusTask.INPROCESS) {
          toastMsg({ data: "Tarea en proceso.", type: "warning" });
          await sleep(2000);
          count++;
        }
        iconAndColorStateUpdate(statusConnectWithLuna);
      }
      if (count == attempts) {
        luna8266.stopTestConnectLuna8266();
        statusConnectWithLuna = StatusTask.ERROR;
        toastMsg({
          data: "Intentos de conexión con la tarjeta terminados sin éxito.",
          type: "error",
          time: 5000,
        });
        iconAndColorStateUpdate(statusConnectWithLuna);
      }
      return;
    }

    // USB ACTIONS
    const serialPorts = ref();
    const serialPortSelected = ref();

    async function scanSerialPortList() {
      toastMsg({
        data: "Finalización de escaneo de dispositivos seriales USB",
        type: "success",
        time: 2000,
      });
      serialPorts.value = await luna8266.getSerialPortList();
    }

    watch(
      () => props.trigger,
      (msg, oldMsg) => {
        console.log(
          "watch: ",
          "trigger value actual: ",
          msg,
          "\ntrigger value old: ",
          oldMsg,
          "\nthis message: "
        );
        if (msg) {
          showModal();
        } else {
          closeModal();
        }
        ipSTALabel.value = luna8266.getIPSTA();
        ipAPLabel.value = luna8266.getIPAP();
        ipSTAEdit.value = luna8266.getIPSTA() != "" ? luna8266.getIPSTA() : "";
      }
    );

    onMounted(() => {
      // console.log(props.parentMessage)
      scanSerialPortList();
      initIconsIDLE();
    });

    return {
      //-- vars template --
      errorLoadFile,
      modalTitle,
      modalDescription,
      methodShippingSelected,
      issdLabel,
      ipSTALabel,
      ipAPLabel,
      ipSTAEdit,
      items,
      serialPorts,
      serialPortSelected,
      iconColorAPNodeMCUStyle,
      iconColorSTANodeMCUStyle,
      iconColorUSBNodeMCUStyle,
      iconAPNodeMCUState,
      iconSTANodeMCUState,
      iconUSBNodeMCUState,
      // -- objects
      luna8266,
      // -- enums
      ShippingMethod,
      //-- METHODS --
      selectMethodShipping,
      testConnect,
      initScanConnect,
      stopScanConnect,
      selectSTAIP,
      scanSerialPortList,
      //-- vars modal --
      isShow,
      showModal,
      closeModal,
    };
  },
});
</script>

<style>
.paragraphClass {
  margin: 15px;
}

.lunaConnect {
  padding: 5px;
  background-color: #131516;
}
.lunaConnectModal {
  width: auto;
  height: 60%;
  /* width: 300px;*/
  padding: 10px;
  box-sizing: border-box;
  background-color: #333;
  font-size: 20px;
  text-align: center;
  position: relative; /* [absolute, relative] */
  top: 20px;
  bottom: 30px;
  overflow: auto; /* [scroll, auto] */
}
.aIconConnectMode {
  padding-left: 15px;
  padding-right: 15px;
  color: white;
}
.aIconConnectMode:hover {
  color: yellow;
  cursor: pointer;
}
.iModeShippingSelected {
  color: green !important;
}
.spanSelected {
  color: green;
}
.textDark {
  color: white;
}
.classMessage {
  height: auto;
  text-align: left;
  white-space: pre; /* habilita \n y \t para <p> */
}
.vue-universal-modal {
  z-index: 71;
}
</style>
